<?php

/**
 * Implements hook_views_handler().
 */
function dynamic_file_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'dynamic_file') . '/views/handlers',
    ),
    'handlers' => array(
      'dynamic_file_handler_field_field' => array(
        'parent' => 'views_handler_field_field',
        'file' => 'dynamic_file_handler_field_field.inc',
      ),
    ),
  );
}

/**
 * Implements hook_views_data_alter().
 *
 * Switch field handler for all media and image fields.
 */
function dynamic_file_views_data_alter(&$data) {
  $fields = array(); //content_fields();
  $fields = field_info_fields();
  foreach ($fields as $field_name => $field) {
    if (in_array($field['type'], array('file', 'image', 'media'))) {
      $table_alias = 'field_data_' . $field['field_name'];
      if (isset($data[$table_alias]) && isset($data[$table_alias][$field_name])) {
        $data[$table_alias][$field_name]['field']['handler'] = 'dynamic_file_handler_field_field';
      }
    }
  }
}
