<?php

class dynamic_file_handler_field_field extends views_handler_field_field {

  function option_definition() {
    $options = parent::option_definition();
    $options['dynamic_file'] = array('default' => FALSE);
    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $formatters = _field_view_formatter_options($field['type']);
    $presets = dynamic_formatters_presets_load_all();
    $form['dynamic_file'] = array(
      '#type' => 'checkbox',
      '#title' => t('Use dynamic formatter'),
      '#description' => t('If checked, this field will use a formatter provided by a dynamic views style.'),
      '#default_value' => $this->options['dynamic_file'],
      '#weight' => 5,
    );
  }

  /**
   * Render callback.
   *
   * @todo Do not hard code $values->nid, use the primary field
   * (with relationships?) instead.
   */
  function render($values) {
    if ($this->options['dynamic_file']) {
      $this->options['format'] = $this->view->style_plugin->dynamic_formatters_renderer->rows[$values->nid]['style']['formatters']['file'];
    }
    return parent::render($values);
  }
}
